???File Path
==========
***...\Src\Travel\AirFareCode.cs




???Check the points
==================



            // ??? IMPORT:- Add the items top - Duplcation Avoid
            using System;
            using System.Data;
            using System.Collections.Generic;
            using Npgsql;
            using NpgsqlTypes;

            using TAAS.Db;
            using TAAS.Models;
            using TAAS.Models.Travel;
            using TAAS.Helpers;
        


            // ??? CLASS ATTRIBUTES:- The code past top of the class(Attributes) - Duplcation Avoid
            public GlobalFunctions insGlobalFunctions = new GlobalFunctions();
            DbService insDbService = new();
        


            public List<MdlBaseIntId> FnGetAllAirFareCodeBaseData()
            {
                List<MdlBaseIntId> lstMdlAirFareCodeBaseIntId = new List<MdlBaseIntId>();

                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_air_fare_code()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlBaseIntId mdlBaseIntId = new MdlBaseIntId();

                        mdlBaseIntId.binPkId = (DBNull.Value != objRecord["pk_air_fare_code_id"]) ? (long)Convert.ToUInt64(objRecord["pk_air_fare_code_id"]) : mdlBaseIntId.binPkId;
                        mdlBaseIntId.strCode = (DBNull.Value != objRecord["vhr_air_fare_code"]) ? Convert.ToString(objRecord["vhr_air_fare_code"]) : mdlBaseIntId.strCode;
                        mdlBaseIntId.strName = (DBNull.Value != objRecord[""]) ? Convert.ToString(objRecord[""]) : mdlBaseIntId.strName;
        
                        lstMdlAirFareCodeBaseIntId.Add(mdlBaseIntId);
                    }
                }

                return lstMdlAirFareCodeBaseIntId;
            }
        


            public List<MdlAirFareCode> FnGetAllAirFareCodeWithActionUser()
            {
                List<MdlAirFareCode> lstMdlAirFareCode = new List<MdlAirFareCode>();
                
                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_air_fare_code_with_action_user()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlAirFareCode mdlAirFareCode = new MdlAirFareCode();

                        
				mdlAirFareCode.binAirFareCodeId = (DBNull.Value != objRecord["pk_air_fare_code_id"]) ? (long)Convert.ToInt64(objRecord["pk_air_fare_code_id"]) : mdlAirFareCode.binAirFareCodeId;
				mdlAirFareCode.binAirFareTypeId = (DBNull.Value != objRecord["fk_air_fare_type_id"]) ? (long)Convert.ToInt64(objRecord["fk_air_fare_type_id"]) : mdlAirFareCode.binAirFareTypeId;

				mdlAirFareCode.binAirlineMasterId = (DBNull.Value != objRecord["fk_airline_master_id"]) ? (long)Convert.ToInt64(objRecord["fk_airline_master_id"]) : mdlAirFareCode.binAirlineMasterId;

				mdlAirFareCode.datEffectiveFrom = (DBNull.Value != objRecord["dat_effective_from"]) ? (DateTime)Convert.ToDateTime(objRecord["dat_effective_from"]) : mdlAirFareCode.datEffectiveFrom;
				mdlAirFareCode.datEffectiveTo = (DBNull.Value != objRecord["dat_effective_to"]) ? (DateTime)Convert.ToDateTime(objRecord["dat_effective_to"]) : mdlAirFareCode.datEffectiveTo;
				mdlAirFareCode.sinEffectiveDateBasedOn = (DBNull.Value != objRecord["sin_effective_date_based_on"]) ? (short)Convert.ToInt16(objRecord["sin_effective_date_based_on"]) : mdlAirFareCode.sinEffectiveDateBasedOn;

				mdlAirFareCode.strAirFareCode = (DBNull.Value != objRecord["vhr_air_fare_code"]) ? Convert.ToString(objRecord["vhr_air_fare_code"]) : mdlAirFareCode.strAirFareCode;


        
                        lstMdlAirFareCode.Add(mdlAirFareCode);
                    }
                }

                return lstMdlAirFareCode;
            }
        


            public MdlResAirFareCode FnInsertOrUpdateAirFareCode(MdlReqAirFareCode mdlReqAirFareCode)
            {
                // *** Input Validation INSERT and UPDATE Case[not duplicate model validation]
                // ??? Duplication Checking in DB FUCTION(Insert and Update) - CODE, NAME [, other unique fields] Already exists
                // ??? Count Exced or other checking License related in DB FUCTION(Insert)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)

                // Set Create or modified User in DB FUCTION(Insert, Update and Delete)
                if (mdlReqAirFareCode.mdlAirFareCode.binAirFareCodeId == 0)
                {
                    mdlReqAirFareCode.mdlAirFareCode.intSysActionId = 0;
                    mdlReqAirFareCode.mdlAirFareCode.binCreatedUserId = mdlReqAirFareCode.linLoginUserId;
                    mdlReqAirFareCode.mdlAirFareCode.strCreatedUser = mdlReqAirFareCode.strLoginUserName;
                    mdlReqAirFareCode.mdlAirFareCode.dtmCreated = mdlReqAirFareCode.dtmCurrentDateTime;
                }
                else {
                    mdlReqAirFareCode.mdlAirFareCode.binLastModifiedUserId = mdlReqAirFareCode.linLoginUserId;
                    mdlReqAirFareCode.mdlAirFareCode.strLastModifiedUser = mdlReqAirFareCode.strLoginUserName;
                    mdlReqAirFareCode.mdlAirFareCode.dtmLastModified = mdlReqAirFareCode.dtmCurrentDateTime;
                }

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("mdlAirFareCode", NpgsqlDbType.Jsonb) { Value = mdlReqAirFareCode.mdlAirFareCode, DataTypeName = "jsnAirFareCode"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_insert_or_update_airFareCode(:mdlAirFareCode, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "AIRFARECODE.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "AIRFARECODE.CS#002", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "AIRFARECODE.CS#003", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Saved
                MdlResAirFareCode mdlResAirFareCode = new MdlResAirFareCode();
                mdlResAirFareCode.mdlAirFareCode = mdlAirFareCodeReq.mdlAirFareCode;
                if (mdlReqAirFareCode.mdlAirFareCode.binAirFareCodeId == 0)
                {
                    mdlResAirFareCode.mdlAirFareCode.binAirFareCodeId = mdlDbResponse.binSqlPk ?? 0;
                    mdlResAirFareCode.mdlAirFareCode.dtmCreated = mdlDbResponse.dtmCurrent;
                }
                else
                {
                    mdlResAirFareCode.mdlAirFareCode.intSysActionId += 1;
                    mdlResAirFareCode.mdlAirFareCode.dtmLastModified = mdlDbResponse.dtmCurrent;
                }
                mdlResAirFareCode.sinStatus = 1;
                mdlResAirFareCode.strStatusCode = "SUCCESS";
                mdlResAirFareCode.strMessage = "AIRFARECODE has been Saved.";
                
                return mdlResAirFareCode;
            } 
        


            public MdlResBaseIntId FnDeleteAirFareCode(MdlReqBaseIntId mdlReqAirFareCodeBaseIntId)
            {
                // *** Input Validation DELETE Case[not duplicate model validation]
                // ??? FOREIGN KEY REFERENCES Ching in DB FUCTION(Delete)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)
                // ??? Set Create or modified User in DB FUCTION(Insert, Update and Delete)

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("binAirFareCodeId", NpgsqlDbType.Bigint) { Value = mdlReqAirFareCodeBaseIntId.mdlBaseIntId.binPkId, DataTypeName = "binAirFareCodeId"},
                    new NpgsqlParameter("intSysActionId", NpgsqlDbType.Integer) { Value = mdlReqAirFareCodeBaseIntId.mdlBaseIntId.binCustomValue, DataTypeName = "intSysActionId"},
                    new NpgsqlParameter("binDeletedUserId", NpgsqlDbType.Bigint) { Value = mdlReqAirFareCodeBaseIntId.linLoginUserId, DataTypeName = "binDeletedUserId"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_delete_airFareCode(:binAirFareCodeId, :intSysActionId, :binDeletedUserId, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "AIRFARECODE.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "AIRFARECODE.CS#005", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "AIRFARECODE.CS#006", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Deleted
                MdlResBaseIntId mdlResAirFareCodeIntId = new MdlResBaseIntId();

                mdlResAirFareCodeIntId.mdlBaseIntId = mdlReqAirFareCodeBaseIntId.mdlBaseIntId;
                mdlResAirFareCodeIntId.sinStatus = 1;
                mdlResAirFareCodeIntId.strStatusCode = "SUCCESS";
                mdlResAirFareCodeIntId.strMessage = "AIRFARECODE has been deleted.";

                return mdlResAirFareCodeIntId;
            }
        

