-- @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
-- @@  AIRTICKET->TBL_AIR_FARE_CODE TBL_AIR_FARE_CODE TBL_AIR_FARE_CODE TBL_AIR_FARE_CODE  @@
-- @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
------------------------------------------------------------------------------------------
            CREATE OR REPLACE FUNCTION fn_get_all_air_fare_code() RETURNS SETOF airticket.tbl_air_fare_code AS $$
                DECLARE

                BEGIN
                    RETURN QUERY SELECT * FROM airticket.tbl_air_fare_code WHERE int_sys_action_id != -1;  
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------
            CREATE OR REPLACE FUNCTION fn_get_all_air_fare_code_with_action_user() 
                            RETURNS TABLE (pk_air_fare_code_id BIGINT,
								fk_air_fare_type_id BIGINT,

								fk_airline_master_id BIGINT,

								dat_effective_from DATE,,
								dat_effective_to DATE,,
								sin_effective_date_based_on SMALLINT,--*1,

								vhr_air_fare_code VARCHAR) AS $$
                DECLARE

                BEGIN
                    RETURN QUERY SELECT mt.pk_air_fare_code_id,
					mt.fk_air_fare_type_id,

					mt.fk_airline_master_id,

					mt.dat_effective_from,
					mt.dat_effective_to,
					mt.sin_effective_date_based_on,

					mt.vhr_air_fare_code
                        FROM airticket.tbl_air_fare_code mt 
                            LEFT JOIN authentication.tbl_user u1
                                ON mt.fk_created_user_id =  u1.pk_user_id
                            LEFT JOIN authentication.tbl_user u2
                                ON mt.fk_last_modified_user_id =  u2.pk_user_id
                            LEFT JOIN authentication.tbl_user u3
                                ON mt.fk_deleted_user_id =  u3.pk_user_id
                        WHERE mt.int_sys_action_id != -1  
                        ORDER BY ;
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------

            CREATE OR REPLACE PROCEDURE sp_insert_or_update_air_fare_code(jsnAirFareCode JSONB, jsnSqlRes OUT JSON) AS $$
                DECLARE
                    objSpOutRes TYP_SP_OUT_RES;
                    objFnCheckRes TYP_FN_CHECK_RES;
                    dtmCurrent TIMESTAMP WITH TIME ZONE;
                BEGIN
                    SELECT NOW() INTO dtmCurrent;

                    -- // Duplication Checking in DB FUCTION(Insert and Update)
                    SELECT * FROM  fn_check_data_uniqueness('airticket.tbl_air_fare_code'::VARCHAR, 'pk_air_fare_code_id'::VARCHAR, jsnAirFareCode->>'binAirFareCodeId'::VARCHAR, 'pk_air_fare_code_id'::VARCHAR, CAST(jsnAirFareCode->>'binAirFareCodeId' AS BIGINT)::BIGINT) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    IF CAST(jsnAirFareCode->>'binAirFareCodeId' AS BIGINT)::BIGINT = 0::BIGINT THEN
                        -- // Count Exced or other checking License related in DB FUCTION(Insert)
                        

                        --jsnAirFareCode.intSysActionId = 0;
                        --jsnAirFareCode.binCreatedUserId = jsnAirFareCode.linLoginUserId;
                        --jsnAirFareCode.dtmCreated = jsnAirFareCode.dtmCurrentDateTime; --SELECT NOW();

                        INSERT INTO airticket.tbl_air_fare_code (fk_air_fare_type_id,

						fk_airline_master_id,

						dat_effective_from,
						dat_effective_to,
						sin_effective_date_based_on,

						vhr_air_fare_code)
                            VALUES(CAST(jsnAirFareCode->>'binAirFareTypeId' AS BIGINT),

						CAST(jsnAirFareCode->>'binAirlineMasterId' AS BIGINT),

						CAST(jsnAirFareCode->>'datEffectiveFrom' AS DATE,),
						CAST(jsnAirFareCode->>'datEffectiveTo' AS DATE,),
						CAST(jsnAirFareCode->>'sinEffectiveDateBasedOn' AS SMALLINT,--*1),

						jsnAirFareCode->>'strAirFareCode') RETURNING pk_air_fare_code_id INTO objSpOutRes.binSqlPk;
                    ELSE
                        -- // UPDATE Check already update another usersin DB FUCTION(Update and Delete)
                        SELECT * FROM  fn_check_already_update_or_delete_another_user('airticket.tbl_air_fare_code'::VARCHAR, 'pk_air_fare_code_id'::VARCHAR, CAST(jsnAirFareCode->>'binAirFareCodeId' AS BIGINT)::BIGINT, CAST(jsnAirFareCode->>'intSysActionId' AS INT)::INT) INTO objFnCheckRes;
                        IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                            objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                            objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                            objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                            objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                            SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                            RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                            RETURN;
                        END IF;

                        --jsnAirFareCode.intSysActionId = jsnAirFareCode.intSysActionId + 1;
                        --jsnAirFareCode.binLastModifiedUserId = jsnAirFareCode.linLoginUserId;
                        --jsnAirFareCode.dtmLastModified = jsnAirFareCode.dtmCurrentDateTime; --SELECT NOW();

                        UPDATE airticket.tbl_air_fare_code SET fk_air_fare_type_id = CAST(jsnAirFareCode->>'binAirFareTypeId' AS BIGINT),

						fk_airline_master_id = CAST(jsnAirFareCode->>'binAirlineMasterId' AS BIGINT),

						dat_effective_from = CAST(jsnAirFareCode->>'datEffectiveFrom' AS DATE,),
						dat_effective_to = CAST(jsnAirFareCode->>'datEffectiveTo' AS DATE,),
						sin_effective_date_based_on = CAST(jsnAirFareCode->>'sinEffectiveDateBasedOn' AS SMALLINT,--*1),

						vhr_air_fare_code = jsnAirFareCode->>'strAirFareCode' 
                        WHERE pk_air_fare_code_id = CAST(jsnAirFareCode->>'binAirFareCodeId' AS BIGINT);
                    END IF;

                    --COMMIT;
                    objSpOutRes.sinSqlCustomStatus := 1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'SUCCESS';
                    objSpOutRes.strSqlCustomMessage := 'AirFareCode Saved';
                    objSpOutRes.dtmCurrent = dtmCurrent;
                    
                    SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                EXCEPTION WHEN OTHERS THEN
                    ROLLBACK;
                    objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                    objSpOutRes.strSqlCustomMessage := 'AirFareCode Save Failed';

                    objSpOutRes.strSqlCustomErrorType := 'DATABASE_SYSTEM_ERROR';

                    GET STACKED DIAGNOSTICS 
				        objSpOutRes.strSqlSysMessage := MESSAGE_TEXT,
                    	objSpOutRes.strSqlSysExceptionDetail := PG_EXCEPTION_DETAIL,
                    	objSpOutRes.strSqlSysExceptionHint := PG_EXCEPTION_CONTEXT;
                
                    SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE EXCEPTION 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------

            CREATE OR REPLACE PROCEDURE sp_delete_air_fare_code(binAirFareCodeId BIGINT, intSysActionId INT, binDeletedUserId BIGINT, jsnSqlRes OUT JSON) AS $$
                DECLARE
                    objSpOutRes TYP_SP_OUT_RES;
                    objFnCheckRes TYP_FN_CHECK_RES;
                    dtmCurrent TIMESTAMP WITH TIME ZONE;
                BEGIN
                    SELECT NOW() INTO dtmCurrent;

                    -- // FOREIGN KEY REFERENCES Checking in DB FUCTION(Delete)
                    SELECT * FROM  fn_check_foreignkey_referance('tbl_air_fare_code'::VARCHAR, 'pk_air_fare_code_id'::VARCHAR, binAirFareCodeId::BIGINT, '{}'::VARCHAR ARRAY) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    -- // UPDATE Check already update another users in DB FUCTION(Update and Delete)
                    SELECT * FROM  fn_check_already_update_or_delete_another_user('airticket.tbl_air_fare_code'::VARCHAR, 'pk_air_fare_code_id'::VARCHAR, CAST(binAirFareCodeId AS BIGINT)::BIGINT, intSysActionId::INT) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    --dtmDeleted = SELECT NOW();
                    UPDATE airticket.tbl_air_fare_code SET int_sys_action_id = -1::INT,
                                fk_deleted_user_id = binDeletedUserId,
                                dtm_deleted = dtmCurrent
                        WHERE pk_air_fare_code_id = binAirFareCodeId;

                    --COMMIT;
                    objSpOutRes.sinSqlCustomStatus := 1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'SUCCESS';
                    objSpOutRes.strSqlCustomMessage := 'AirFareCode Deleted';
                    objSpOutRes.dtmCurrent = dtmCurrent;

                    SELECT * FROM fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                EXCEPTION WHEN OTHERS THEN
                    ROLLBACK;
                    objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                    objSpOutRes.strSqlCustomMessage := 'AirFareCode Delete Failed';

                    objSpOutRes.strSqlCustomErrorType := 'DATABASE_SYSTEM_ERROR';

                    GET STACKED DIAGNOSTICS 
				        objSpOutRes.strSqlSysMessage := MESSAGE_TEXT,
                    	objSpOutRes.strSqlSysExceptionDetail := PG_EXCEPTION_DETAIL,
                    	objSpOutRes.strSqlSysExceptionHint := PG_EXCEPTION_CONTEXT;

                    SELECT * FROM fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE EXCEPTION 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                END;
            $$ LANGUAGE plpgsql;
        

